# a pesudo training framework
from ast import arg
import os
import argparse
from datetime import datetime
from os.path import join
import re
import numpy as np

# evaluate runs in terms of RL rewards

root_path = os.getcwd()
    
os.chdir(root_path)
# nohup python tools/evaluate_RL.py --nlabels 6000 --seed 10 --nplabels 2500 --fine_tune -e 300 -b 64 --num_rounds 1 --supervised --duration 480 --fixed_order --semiRL --repeat 1 --pretrained log/timeBased/0809134923/1/ >> out0831 &
parser = argparse.ArgumentParser(description='CryoEM_Pseudo_Training')
parser.add_argument('--nlabels', type=int, default=125)
parser.add_argument('--seed', type=int, default=3)
parser.add_argument('--dataset', type=str, default="Y3_2Cat")
parser.add_argument('--pretrained', type=str, default=None)
parser.add_argument('--fixed_order', action="store_true")
parser.add_argument('--semiRL', action= 'store_true')
parser.add_argument('--repeat', type=int, default=5)
parser.add_argument('--gpu_id', type = int, help='comma separated list of GPU(s) to use.', default=0)
parser.add_argument('--sub_dir', nargs="*", type = str, default= None, help='evaluate a specific subdir')
parser.add_argument('--RL_model', type = str, default= "DQN")
parser.add_argument('--no_cost', action = 'store_true')

# the following are unused
parser.add_argument('--ctf_thred', type=int, default=6)
parser.add_argument('--nplabels', type=int, default=100)
parser.add_argument('--fine_tune', action='store_true')
parser.add_argument('-e', type=int, default=100)
parser.add_argument('-b', type=int, default=16)
parser.add_argument('--num_rounds', type = int, default=10)
parser.add_argument('--lr', type = float, default=0.001)
parser.add_argument('--use_one_hot', action="store_true")
parser.add_argument('--bayesian', action="store_true", help = "use bayesian calibration")
parser.add_argument('--supervised', action="store_true")
parser.add_argument('--use_clf', action="store_true")
parser.add_argument('--traj_num', type=int, default= 5)
parser.add_argument('--duration', type=int, default= 480)
parser.add_argument('--patch', action="store_true")
parser.add_argument('--confidence', type = float, default=0, help="keep samples max(p) > confidence")
parser.add_argument('--eff_size', type = int, default=1, help="ratio between labeled and pesudo labeled")
parser.add_argument('--traj_power', type = int, default=4, help="power for trajectory weight")

global args
args = parser.parse_args()

if not os.path.exists(args.pretrained):
    args.model_path = os.path.join(root_path, "CryoEM_Img", "log/timeBased", args.pretrained)
else:
    args.model_path = args.pretrained
os.chdir("CryoEM_Img")

if args.use_one_hot:
    use_one_hot = "--use_one_hot"
else:
    use_one_hot = ""
if args.fixed_order:
    fixed_order = "--fixed_order"
else:
    fixed_order = ""
if args.no_cost:
    no_cost = "--no_cost"
else:
    no_cost = ""
    

if args.dataset == "Y1_3Cat":
    args.config_file = "Y1_3Lab_48.yaml"
    args.RL_dataset = "Y1_3Cat"
    args.thred = "4 8"
    args.ctf_file = "CryoEM_Config/Y1_CTF_by_hl.csv"
elif args.dataset == "Y1_2Cat":
    if args.patch:
        args.config_file = "Y1_2Cat_6_Patch.yaml"
    else:
        args.config_file = "Y1_2Cat_6.yaml"
    args.RL_dataset = "Y1_2Cat"
    args.thred = "6"
    args.ctf_file = "CryoEM_Config/Y1_CTF_by_hl.csv"
elif args.dataset == "Y3_2Cat":
    if args.patch:
        args.config_file = "Y3_2Cat_6_Patch.yaml"
    else:
        args.config_file = "Y3_SL.yaml"
    args.RL_dataset = "Y3_2Cat"
    args.thred = "6"
    args.ctf_file = "CryoEM_Config/Y3_CTF_by_hl.csv"
else:
    raise NotImplementedError

start = 0
dirs = [name for name in os.listdir(args.model_path) if os.path.isdir(os.path.join(args.model_path, name))]
dirs.sort()
dirs = [""] + dirs

def get_img_acc(output):
    idf = "Validation Acc: "
    n = len(idf)
    o = re.search(idf, output)
    return float(output[o.start()+n:])

def get_RL_acc(output):
    idf = "Final reward: "
    n = len(idf)
    o = re.search(idf, output)
    e = re.search("\\+", output)
    return float(output[o.start()+n: e.start()-1])

if args.sub_dir is not None:
    dirs = args.sub_dir
for sub_dir in dirs:
    rwds = []
    os.chdir(root_path)
    os.chdir("CryoEM_Img")
        
    if args.semiRL:
        os.system("python train.py --config configs/%s --seed %d --nlabels %d -e --pretrained %s --backbone_net resnet18 --val train --gpu_id %d %s" % (args.config_file, args.seed, args.nlabels, join(args.model_path, sub_dir, "model_best.pth.tar"), args.gpu_id, fixed_order))
        
        # replace train file
        os.system("python tools/update_gt_ctf.py --source_file %s --target_file %s --ctf_file %s --thred %s --confidence %s"%(join(args.model_path, sub_dir, "train_by_hl.txt"), join(args.model_path, sub_dir, "val_by_hl.txt"), join(root_path, "CryoRL-pytorch", args.ctf_file), args.thred, str(args.confidence)))
        
        if os.path.exists(join(args.model_path, sub_dir, 'train_by_hl_tmp.txt')):
            os.system("rm %s"%(join(args.model_path, sub_dir, 'train_by_hl_tmp.txt')))
        os.system("cat %s >> %s" % (join(args.model_path, sub_dir, "train_by_hl.txt"), join(args.model_path, sub_dir, 'train_by_hl_tmp.txt')))
            
        R1 = os.popen("python train.py --config configs/%s --seed %d --nlabels %d -e --pretrained %s --backbone_net resnet18 --gpu_id %d %s" % (args.config_file, args.seed, args.nlabels, join(args.model_path, sub_dir, "model_best.pth.tar"), args.gpu_id, fixed_order))
        output1 = R1.read()
        val_acc = get_img_acc(output1)
        os.system("rm %s"%(join(args.model_path, sub_dir, "train_by_hl.txt")))
        os.system("cat %s >> %s" % (join(args.model_path, sub_dir, "train_by_hl_tmp.txt"), join(args.model_path, sub_dir, 'train_by_hl.txt')))
    else:
        R1 = os.popen("python train.py --config configs/%s --seed %d --nlabels %d -e --pretrained %s --backbone_net resnet18 --gpu_id %d %s" % (args.config_file, args.seed, args.nlabels, join(args.model_path, sub_dir, "model_best.pth.tar"), args.gpu_id, fixed_order))
        output1 = R1.read()
        val_acc = get_img_acc(output1)
    os.chdir("../CryoRL-pytorch")
    for i in range(args.repeat):
        if args.semiRL:
            os.system("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --seed %d --ctf-thresh %d --train-prediction --test-prediction --duration %d --train_pred_rw %s --epoch 10 --gpu %d --model %s > /dev/null" % (join(args.model_path, sub_dir), args.RL_dataset, i+args.seed, args.ctf_thred, args.duration, use_one_hot, args.gpu_id, args.RL_model))
        else:
            os.system("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --seed %d --ctf-thresh %d --train-prediction --test-prediction --duration %d  %s --epoch 10 --gpu %d --model %s > /dev/null" % (join(args.model_path, sub_dir), args.RL_dataset, i+args.seed, args.ctf_thred, args.duration, use_one_hot, args.gpu_id, args.RL_model))
        
        R2 = os.popen("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --ctf-thresh %d --train-prediction --test-prediction  --duration %d --eval %s --gpu %d --final_eval --model %s %s" % (join(args.model_path, sub_dir), args.RL_dataset, args.ctf_thred, args.duration, use_one_hot, args.gpu_id, args.RL_model, no_cost))
        output2 = R2.read()
        rl_rwd = get_RL_acc(output2)
        print(rl_rwd)
        rwds.append(rl_rwd)
    os.chdir("../CryoEM_Img")
    rwd_avg = np.mean(rwds)
    rwd_std = np.std(rwds)
    if args.semiRL and (not args.no_cost):
        output_file = "RL_rwd.txt"
    elif args.no_cost:
        output_file = "RL_rwd_no_cost.txt"
    else:
        output_file = "RL_rwd_sup.txt"
        
    with open(join(args.model_path, output_file), 'a') as f:
        print(f"{sub_dir}, {val_acc}, {rwd_avg}, {rwd_std}", file = f)
    