# get clf metrics
from ast import arg
import os
import sys
import csv
import argparse
from datetime import datetime
from os.path import join
import re
import numpy as np
import logging
from sklearn import metrics
parser = argparse.ArgumentParser(description='Evaludate classifier')
parser.add_argument('--dir', type=str, default=None)

global args
args = parser.parse_args()

def get_metrics(vec):
    fpr, tpr, thresholds = metrics.roc_curve(vec['true'], vec['score'], pos_label=0)
    auc = metrics.auc(fpr, tpr)
    prec_score = metrics.precision_score(vec['true'], vec['pred'])
    acc = metrics.accuracy_score(vec['true'], vec['pred'])
    f1 = metrics.f1_score(vec['true'], vec['pred'])
    rcl = metrics.recall_score(vec['true'], vec['pred'])
    blc_acc = metrics.balanced_accuracy_score(vec['true'], vec['pred'])
    # print(metrics.classification_report(vec['true'], vec['pred']))
    return (acc, blc_acc, auc, prec_score, f1, rcl)


f = open(join(args.dir, 'clf_summary.csv'), 'w')
writter = csv.writer(f, delimiter=',')
writter.writerow(['round', 'acc', 'blc_acc', 'auc', 'prec', 'f1', 'rcl'])
train_res = []
val_res = []

for file in ['', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10']:
    d = os.path.join(args.dir, file)
    if os.path.isdir(d):
        assert os.path.exists(join(d, "train_by_hl.txt")), "Model need to be evaluated" 

        train_hl = np.loadtxt(join(d, "train_by_hl.txt"), dtype = 'str')
        val_hl = np.loadtxt(join(d, "val_by_hl.txt"), dtype = 'str')
            
        convert = lambda x: int(x == "high")
            
        train_vec = {'pred': np.array(list(map(convert, train_hl[:, -1]))),
                        'true': np.array(list(map(convert, train_hl[:, -2]))), 
                        'score': np.array(list(train_hl[:, -4])).astype('float')}
        val_vec = {'pred': np.array(list(map(convert, val_hl[:, -1]))),
                    'true': np.array(list(map(convert, val_hl[:, -2]))), 
                    'score': np.array(list(val_hl[:, -4])).astype('float')}
        train_res += [[file+'train'] + list(get_metrics(train_vec))]
        val_res += [[file+'val'] + list(get_metrics(val_vec))]

writter.writerows(train_res)
writter.writerows(val_res)
f.close()
os.system('cat %s'%(join(args.dir, 'clf_summary.csv')))
print("Saved to %s" % ((join(args.dir, 'clf_summary.csv'))))
    