# see logs
import argparse
import os
from os.path import join
import numpy as np
import subprocess


parser = argparse.ArgumentParser(description='Show logs')
parser.add_argument('--timestamp', type=str, default=None)
args = parser.parse_args()

root_path = os.getcwd()

if args.timestamp is None:
    dirs = [(timestamp) for timestamp in os.listdir(join(root_path, "log", "timeBased"))]
    dirs.sort()
    print(dirs)
    print(f"Showing the latest run {dirs[-1]}")
    args.timestamp = dirs[-1]

args.model_path = join(root_path, "log", 'timeBased', args.timestamp)
assert args.timestamp is not None and os.path.exists(args.model_path), "Invalid timeStamp: %s not exists" %(args.model_path)
dirs = ([ name for name in os.listdir(args.model_path) if os.path.isdir(os.path.join(args.model_path, name))])
dirs.sort()
print("---------List of runs---------\n", dirs)
print("---------Run info---------")
os.system("cat %s |grep train.py" % (join(args.model_path, "1", "log.log")))
print("---------Round overview---------")
os.system("cat %s" % (join(args.model_path, "round_log.txt")))
if os.path.exists(join(args.model_path, "RL_rwd.txt")):
    print("---------RL Semi evaluated---------")
    os.system("cat %s" % (join(args.model_path, "RL_rwd.txt")))
if os.path.exists(join(args.model_path, "RL_rwd_sup.txt")):
    print("---------RL Sup evaluated---------")
    os.system("cat %s" % (join(args.model_path, "RL_rwd_sup.txt")))
if os.path.exists(join(args.model_path, "RL_rwd_no_cost.txt")):
    print("---------RL No Cost evaluated---------")
    os.system("cat %s" % (join(args.model_path, "RL_rwd_no_cost.txt")))

if os.path.exists(join(args.model_path, "clf_summary.csv")):
    print("---------Evaluate classifer---------")
    os.system("perl -pe 's/((?<=,)|(?<=^)),/ ,/g;' '%slog/timeBased/%s/clf_summary.csv' | column -c 8 -t -s, | less  -F -S -X -K"%(root_path, args.timestamp))
