# a pesudo training framework
from ast import arg
from cProfile import label
import os
import csv
import sys
import argparse
import matplotlib.pyplot as plt
plt.rcParams['figure.figsize'] = [8, 4]
from datetime import datetime
from os.path import join
import re
import numpy as np
import logging


# visualization config
color_seq = ['y', 'k', 'g']
metrics = {'Acc': 1,
           'Reward': 2,
           'acc': ['Accuracy', 1],
           'blc_acc': ['Balanced Acc', 2],
           'auc': ['AUC', 3],
           'prec': ['Precision', 4],
           'f1': ['F1', 5],
           'rcl': ['Recall', 6]}

root_path = os.getcwd()

os.chdir(join(root_path, "CryoEM_Img"))

parser = argparse.ArgumentParser(description='CryoEM_Visualization')
# parser.add_argument('--runs', nargs="+", type=str, default=["0713133122", "0713133339", "0713233129"])
parser.add_argument('--runs', nargs="+", type=str, default=["0802101913", "0909100004", "0802102034"])
# parser.add_argument('--runs', nargs="+", type=str, default=["0802101913", "0801114451", "0802102034"])
parser.add_argument('--names', nargs="+", type=str, default=["5%", "10%", "20%"])
parser.add_argument('--max_round', type=int, default=10)
parser.add_argument('--test', nargs="+", type=str, default=['Acc', 'Reward'])
global args
args = parser.parse_args()



for m in args.test:
    if m in ["acc","blc_acc","auc","prec","f1","rcl"]:
        for j in range(len(args.runs)):
            run = args.runs[j]
            col = color_seq[j]

            tmp = join("log/timeBased", run, "clf_summary.csv")
            dat = np.loadtxt(tmp, delimiter=',', dtype='str', skiprows = 0)
            read = list(map(lambda x: str(x)+'val', list(range(args.max_round))))
            read[0] = 'val'
            read_dat = []
            for i in range((dat.shape[0])):
                if dat[i, 0] in read:
                    if dat[i, 0] == 'val':
                        dat[i, 0] = 0
                    else:
                        dat[i, 0] = int(dat[i, 0][:(-3)])
                    read_dat.append(dat[i, :].astype(float))
            read_dat = np.array(read_dat)
            plt.plot(read_dat[:, 0], read_dat[:, metrics[m][1]], color = col, label = args.names[j])
        plt.legend()
        plt.xlabel("Rounds")
        # plt.ylim([0.64, 0.668])
        plt.ylabel(metrics[m][0])
        # plt.show()
        plot_file_name = f'test_{metrics[m][0]}'
        plt.savefig(os.path.join("visual", plot_file_name+'.pdf'))
        print("Saving to: %s"%(os.path.join("visual", plot_file_name+'.pdf')))
        plt.close()
    else:
        for j in range(len(args.runs)):
            run = args.runs[j]
            col = color_seq[j]
            tmp = join("log/timeBased", run, "RL_rwd.txt")
            if os.path.exists(tmp):
                dat = np.loadtxt(tmp, delimiter=',', dtype='str')
                sup_line = None
                if dat[0, 0] == '':
                    dat[0, 0] = '0'
                for i in range(dat.shape[0]):
                    if dat[i, 0] == 'sup':
                        sup_line = dat[i, :]
                        dat = np.delete(dat, i, 0)
                print(dat)
                dat = dat.astype(float)
                dat = dat[dat[:, 0].argsort()]
                if dat.shape[0] >= args.max_round:
                    dat = dat[:args.max_round, :]
                plt.plot(dat[:, 0], dat[:, metrics[m]], color = col, label = args.names[j])
                if not sup_line is None:
                    plt.axhline(y=float(sup_line[metrics[m]]), color='r', linestyle='-', label = 'Supervised')
        # ax = plt.gca()
        # ax.set_xlim([xmin, xmax])
        
        plt.legend()
        plt.xlabel("Rounds")
        plt.ylabel(m)
        # plt.show()
        plot_file_name = f'test_{m}'
        plt.savefig(os.path.join("visual", plot_file_name+'.pdf'))
        print("Saving to: %s"%(os.path.join("visual", plot_file_name+'.pdf')))
        plt.close()
