# a pesudo training framework
from ast import arg
import os
import csv
import sys
import argparse
import matplotlib.pyplot as plt
plt.rcParams['figure.figsize'] = [8, 4]
from datetime import datetime
from os.path import join
import re
import numpy as np
import logging


# visualization config
color_seq = ['y', 'k', 'g']
metrics = {'Acc': 1, 'Reward': 2}

root_path = os.getcwd()

os.chdir(join(root_path, "CryoEM_Img"))

parser = argparse.ArgumentParser(description='CryoEM_Visualization')
parser.add_argument('--runs', nargs="+", type=str, default=["0801114647"])
parser.add_argument('--names', nargs="+", type=str, default=["5%"])
global args
args = parser.parse_args()

for m in ['Reward']:
    for j in range(len(args.runs)):
        run = args.runs[j]
        col = color_seq[j]
        tmp = join("log/timeBased", "0801114451", "RL_rwd_sup.txt")
        tmp2 = join("log/timeBased", run, "RL_rwd_sup.txt")
        fig, ax = plt.subplots()
        if os.path.exists(tmp):
            dat = np.loadtxt(tmp, delimiter=',', dtype='str')
            sup_line = None
            if dat[0, 0] == '':
                dat[0, 0] = '0'
            for i in range(dat.shape[0]):
                if dat[i, 0] == 'sup':
                    sup_line = dat[i, :]
                    dat = np.delete(dat, i, 0)
            if dat.shape[0] > 11:
                dat = dat[:11, :]
            print(dat)
            dat = dat.astype(float)
            dat = dat[dat[:, 0].argsort()]
            ax.plot(dat[:, 0], dat[:, metrics[m]], color = 'g', label = 'SemiRL')
            ax.fill_between(dat[:, 0], dat[:, metrics[m]] - dat[:, metrics[m]+1], dat[:, metrics[m]] + dat[:, metrics[m]+1], color = 'g', alpha = 0.3)
        if os.path.exists(tmp2):
            dat = np.loadtxt(tmp2, delimiter=',', dtype='str')
            sup_line = None
            if dat[0, 0] == '':
                dat[0, 0] = '0'
            for i in range(dat.shape[0]):
                if dat[i, 0] == 'sup':
                    sup_line = dat[i, :]
                    dat = np.delete(dat, i, 0)
            if dat.shape[0] > 11:
                dat = dat[:11, :]
            print(dat)
            dat = dat.astype(float)
            dat = dat[dat[:, 0].argsort()]
            ax.plot(dat[:, 0], dat[:, metrics[m]], color = 'y', label = 'SupRL')
            ax.fill_between(dat[:, 0], dat[:, metrics[m]] - dat[:, metrics[m]+1], dat[:, metrics[m]] + dat[:, metrics[m]+1], color = 'y', alpha = 0.3)

    plt.legend()
    plt.xlabel("Rounds")
    plt.ylabel(m)
    # plt.show()
    plot_file_name = f'Semi-Sup-RL-{m}'
    plt.savefig(os.path.join("visual", plot_file_name+'.pdf'))
    print("Saving to: %s"%(os.path.join("visual", plot_file_name+'.pdf')))
    plt.close()
