# a pesudo training framework
from ast import arg
import os
import csv
import sys
import argparse
import matplotlib.pyplot as plt
plt.rcParams['figure.figsize'] = [8, 4]
from datetime import datetime
from os.path import join
import re
import numpy as np
import logging


# visualization config
color_seq = ['y', 'k', 'g']
metrics = {'Acc': 1, 'Reward': 2}

root_path = os.getcwd()

os.chdir(join(root_path, "CryoEM_Img"))

parser = argparse.ArgumentParser(description='CryoEM_Visualization')
parser.add_argument('--runs', nargs="+", type=str, default=["0801114647", "0801114451", "0801114727"])
parser.add_argument('--names', nargs="+", type=str, default=["5%", "10%", "20%"])
global args
args = parser.parse_args()

for m in metrics.keys():
    sup_dat = []
    semi_dat = []
    
    for j in range(len(args.runs)):
        run = args.runs[j]
        col = color_seq[j]
        tmp = join("log/timeBased", run, "RL_rwd.txt")
        if os.path.exists(tmp):
            dat = np.loadtxt(tmp, delimiter=',', dtype='str')
            print(dat)
            for i in range(dat.shape[0]):
                if dat[i, 0] == 'sup':
                    sup_dat.append(dat[i, :])
                    break
            for i in range(dat.shape[0]):
                if dat[i, 0] == '':
                    semi_dat.append(dat[i, :])
                    break
    # print(sup_dat)
    # print(semi_dat)
    if m == 'Reward':
        sup_uncertain = np.array(list(map(lambda x: float(x[metrics[m]+1]), sup_dat)))
        semi_uncertain = np.array(list(map(lambda x: float(x[metrics[m]+1]), semi_dat)))
    sup_dat = np.array(list(map(lambda x: float(x[metrics[m]]), sup_dat)))
    semi_dat = np.array(list(map(lambda x: float(x[metrics[m]]), semi_dat)))

    fig, ax = plt.subplots()
    ax.plot(args.names, sup_dat, color = 'g', label = "Supervised")
    ax.plot(args.names, semi_dat, color = 'y', label = "Fixmatch")
    if m == 'Reward':
        ax.fill_between(args.names, sup_dat - sup_uncertain / 10, sup_dat + sup_uncertain/ 10, alpha = 0.3, color = 'g')
        ax.fill_between(args.names, semi_dat - semi_uncertain/ 10, semi_dat + semi_uncertain/ 10, alpha = 0.3, color = 'y')
    plt.legend()
    plt.xlabel("Proportion of labeled data")
    plt.ylabel(m)
    # plt.show()
    plot_file_name = f'Compare_sup_{m}'
    plt.savefig(os.path.join("visual", plot_file_name+'.pdf'))
    print("Saving to: %s"%(os.path.join("visual", plot_file_name+'.pdf')))
    plt.close()
