# a pesudo training framework
from ast import arg
import os
import sys
import argparse
from datetime import datetime
from os.path import join
import re
import numpy as np
import logging

root_path = os.getcwd()
    
# os.chdir(root_path)
parser = argparse.ArgumentParser(description='CryoEM_Pseudo_Training')
parser.add_argument('--pretrained', type=str, default=None)
parser.add_argument('--nlabels', type=int, default=125)
parser.add_argument('--seed', type=int, default=3)
parser.add_argument('--dataset', type=str, default="Y3_2Cat")
parser.add_argument('--ctf_thred', type=int, default=6)
parser.add_argument('--nplabels', type=int, default=2500)
parser.add_argument('--fine_tune', action='store_true')
parser.add_argument('-e', type=int, default=200)
parser.add_argument('-b', type=int, default=64)
parser.add_argument('--num_rounds', type = int, default=10)
parser.add_argument('--lr', type = float, default=0.001)
parser.add_argument('--use_one_hot', action="store_true")
parser.add_argument('--bayesian', action="store_true", help = "use bayesian calibration")
parser.add_argument('--supervised', action="store_true")
parser.add_argument('--use_clf', action="store_true")
# parser.add_argument('--weighted', type=str, default="by_full_traj", choices=["by_full_traj", "by_eff_size", "regular"])
parser.add_argument('--traj_num', type=int, default= 5)
parser.add_argument('--duration', type=int, default= 120)
parser.add_argument('--patch', action="store_true")
parser.add_argument('--fixed_order', action="store_true")
parser.add_argument('--no_cost', action="store_true")
parser.add_argument('--confidence', type = float, default=0, help="keep samples max(p) > confidence")
parser.add_argument('--eff_size', type = int, default=1, help="ratio between labeled and pesudo labeled")
parser.add_argument('--traj_power', type = int, default=4, help="power for trajectory weight")
parser.add_argument('--RL_model', type = str, default="DQN")

global args
args = parser.parse_args()

os.chdir("CryoEM_Img")

if args.use_one_hot:
    use_one_hot = "--use_one_hot"
else:
    use_one_hot = ""
    
if args.fixed_order:
    fixed_order = "--fixed_order"
else:
    fixed_order = ""
    
if args.bayesian:
    bayesian = "--bayesian"
else:
    bayesian = ""
    
if args.no_cost:
    no_cost = "--no_cost"
else:
    no_cost = ""


if args.dataset == "Y3_2Cat":
    if args.patch:
        args.config_file = "Y3_2Cat_6_Patch.yaml"
    else:
        args.config_file = "Y3_SL.yaml"
    args.RL_dataset = "Y3_2Cat"
    args.thred = "6"
    args.ctf_file = "CryoEM_Config/Y3_CTF_by_hl.csv"
else:
    raise NotImplementedError

# if args.weighted:
#     weighted = "--weighted_data by_trajectory"
# else:
#     weighted = ""

if args.pretrained is None:
    dt = datetime.now()
    # getting the timestamp
    timestamp = dt.strftime("%m%d%H%M%S")
    args.timestamp = timestamp
    args.model_path = join(root_path, 'CryoEM_Img', 'log/timeBased', args.timestamp)
    if not os.path.exists(args.model_path):
        os.makedirs(args.model_path)
    with open(join(args.model_path, "round_log.txt"), 'a') as f:
        tmp = [x+' ' for x in sys.argv]
        print(''.join(tmp), file = f)
        print(args, file = f)
    args.logger = open(join(args.model_path, 'round_log.log'), 'a')
    sys.stdout = args.logger
    sys.stderr = args.logger
    # this is the initial model
    if args.supervised:
        os.system("python train.py --config configs/%s --lr %f --seed %d --nlabels %d --abs_log_dir %s --backbone_net resnet18 --p_cutoff 0.8 -b %d --epochs %d -u 0.0 --uratio 1 --group %s --prefix sup --lazy_eval %s" % (args.config_file, args.lr, args.seed, args.nlabels, join(args.model_path, 'sup'), args.b, args.e, args.timestamp, fixed_order))
        exit()
    os.system("python train.py --config configs/%s --lr %f --seed %d --nlabels %d --abs_log_dir %s --backbone_net resnet18 --p_cutoff 0.8 -b %d --epochs %d -u 5.0 --uratio 4 --group %s --lazy_eval %s" % (args.config_file, args.lr, args.seed, args.nlabels, args.model_path, args.b, args.e, args.timestamp, fixed_order))

    # train a model without pseudo labels
else:
    if args.pretrained.isdigit() or args.pretrained == 'C51':
        args.timestamp = args.pretrained
        args.model_path = join(root_path, "CryoEM_Img", "log", "timeBased", args.pretrained)
    else:
        if re.search('timeBased',args.pretrained) is not None:
            o = re.search('timeBased',args.pretrained)
            args.timestamp = args.pretrained[o.start()+10:o.start()+20]
        else:
            dt = datetime.now()
            # getting the timestamp
            timestamp = dt.strftime("%m%d%H%M%S")
            args.timestamp = timestamp

        args.model_path = join(root_path, "CryoEM_Img", args.pretrained)
    if not os.path.exists(args.model_path):
        os.makedirs(args.model_path)
    with open(join(args.model_path, "round_log.txt"), 'a') as f:
        tmp = [x+' ' for x in sys.argv]
        print(''.join(tmp), file = f)
        print(args, file = f)
    
    if args.supervised:
        os.system("python train.py --config configs/%s --lr %f --seed %d --nlabels %d --abs_log_dir %s --backbone_net resnet18 --p_cutoff 0.8 -b %d --epochs %d -u 0.0 --uratio 1 --group %s --prefix sup --lazy_eval %s" % (args.config_file, args.lr, args.seed, args.nlabels, join(args.model_path, 'sup'), args.b, args.e, args.timestamp, fixed_order))
        exit()
    
    args.logger = open(join(args.model_path, 'round_log.log'), 'a')
    sys.stdout = args.logger
    sys.stderr = args.logger
    # args.num_rounds = 1 # when use pretrained, we do not do multiplt round training
# model_path should be absolute path

def get_img_acc(output):
    idf = "Validation Acc: "
    n = len(idf)
    o = re.search(idf, output)
    return float(output[o.start()+n:])
def get_RL_acc(output):
    idf = "Final reward: "
    n = len(idf)
    o = re.search(idf, output)
    e = re.search("\\+", output)
    return float(output[o.start()+n: e.start()-1])

def one_evaluate(args, sub_dir = ""):
    os.chdir(root_path)
    os.chdir("CryoEM_Img")
    R1 = os.popen("python train.py --config configs/%s --seed %d --nlabels %d -e --pretrained %s --backbone_net resnet18 %s --gpu_id 0 %s" % (args.config_file, args.seed, args.nlabels, join(args.model_path, sub_dir, "model_best.pth.tar"), bayesian, fixed_order))
    output1 = R1.read()
    val_acc = get_img_acc(output1)
    
    os.chdir("../CryoRL-pytorch")
    R2 = os.popen("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --ctf-thresh %d --train-prediction --test-prediction  --duration %d --eval %s --final_eval --model %s" % (join(args.model_path, sub_dir), args.RL_dataset, args.ctf_thred, args.duration, use_one_hot, args.RL_model))
    output2 = R2.read()
    try:
        rl_rwd = get_RL_acc(output2)
    except AttributeError:
        rl_rwd = 0.0
    return val_acc, rl_rwd
    

def one_feedback_rd(args, sub_dir = "", output_dir = "1"):
    os.chdir(root_path)
    os.chdir("CryoEM_Img")
    os.system("python train.py --config configs/%s --seed %d --nlabels %d -e --pretrained %s --backbone_net resnet18 --val train %s --gpu_id 0 %s" % (args.config_file, args.seed, args.nlabels, join(args.model_path, sub_dir, "model_best.pth.tar"), bayesian, fixed_order))
    
    # replace train file
    os.system("python tools/update_gt_ctf.py --source_file %s --target_file %s --ctf_file %s --thred %s --confidence %s"%(join(args.model_path, sub_dir, "train_by_hl.txt"), join(args.model_path, sub_dir, "val_by_hl.txt"), join(root_path, "CryoRL-pytorch", args.ctf_file), args.thred, str(args.confidence)))

    if args.use_clf:
        os.system("python tools/generate_pesudo.py --file %s --source from_clf --out %s" % (join(args.model_path, sub_dir, "val_by_hl.txt"), join(args.model_path, "pesudo_labels.csv")))
    else:
        os.chdir("../CryoRL-pytorch")
        os.system("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --seed 2 --ctf-thresh %d --train-prediction --test-prediction --duration %d --train_pred_rw %s --epoch 5 %s --model %s" % (join(args.model_path, sub_dir), args.RL_dataset, args.ctf_thred, args.duration, use_one_hot, no_cost, args.RL_model))
        pos_acc = []
        neg_acc = []
        for i in range(args.traj_num):
            # evaluate RL on training and generate trajectory
            os.system("python train.py --prediction_file %s --dataset %s --lr 0.001 --training-num 10 --test-num 10 --step-per-epoch 500 --ctf-thresh %d  --train-prediction --test-prediction --hard_step 10000 --duration 480 --eval --print-trajectory %s --seed %d --model %s > /dev/null" % (join(args.model_path, sub_dir), args.RL_dataset, args.ctf_thred, use_one_hot, i, args.RL_model))
            trj = np.loadtxt(join(args.model_path, sub_dir, "evaluate_trajectory.txt"), delimiter=' ', dtype=str)
            if args.nplabels > trj.shape[0]/2:
                args.nplabels = int(trj.shape[0]/2)
            trj_pos = trj[:args.nplabels, :]
            trj_pos = np.concatenate(((np.zeros(args.nplabels).reshape(-1, 1)+1).astype(int).astype(str), trj_pos), axis = 1)
            pos_acc.append(np.sum(trj_pos[:, -1].astype(float) > 0) / args.nplabels)
            trj_neg = trj[-args.nplabels:, :]
            trj_neg = np.concatenate(((np.zeros(args.nplabels).reshape(-1, 1)).astype(int).astype(str), trj_neg), axis = 1)
            trj = np.concatenate([trj_pos, trj_neg])
            neg_acc.append(np.sum(trj_neg[:, -1].astype(float) == 0) / args.nplabels)
            np.savetxt(join(args.model_path, sub_dir, "evaluate_trajectory.txt"), trj, fmt = '%s')
            # append new trajectory to the old one
            if sub_dir != '':
                os.system('cat %s >> %s' % (join(args.model_path, sub_dir, "evaluate_trajectory.txt"), join(args.model_path, "evaluate_trajectory.txt")))
        os.chdir("../CryoEM_Img")
        os.system("python tools/generate_pesudo.py --file %s --source from_traj --out %s" % (join(args.model_path, "evaluate_trajectory.txt"), join(args.model_path, "pesudo_labels.csv")))
    
    # os.system("cat %s/evaluate_trajectory.txt"%(join(args.model_path)))
    if args.fine_tune:
        os.system("python train.py --config configs/%s --pretrained %s --lr %f --seed %d --nlabels %d --pseudo_label %s --backbone_net resnet18 --p_cutoff 0.8 -b %d --abs_log_dir %s --epochs %d -u 5.0 --uratio 1 --group %s --prefix %s_ --eff_size %d --traj_power %d %s" % (args.config_file, join(args.model_path, sub_dir, "model_best.pth.tar"), args.lr / 10, args.seed, args.nlabels, join(args.model_path, "pesudo_labels.csv"), args.b, join(args.model_path, output_dir), args.e / 5, args.timestamp, sub_dir, args.eff_size, args.traj_power, fixed_order))
    else:
        os.system("python train.py --config configs/%s --lr %f --seed %d --nlabels %d --pseudo_label %s --backbone_net resnet18 --p_cutoff 0.8 -b %d --abs_log_dir %s --epochs %d -u 5.0 --uratio 4 --group %s --prefix %s_  --eff_size %d --lazy_eval %s" % (args.config_file, args.lr, args.seed, args.nlabels, join(args.model_path, "pesudo_labels.csv"), args.b, join(args.model_path, output_dir), args.e, args.timestamp, sub_dir, args.eff_size, fixed_order))
    # always use the trajectory file in the root directory
    if args.use_clf:
        return 0, 0
    else:
        return np.mean(pos_acc), np.mean(neg_acc)
start = 0
dirs = [ name for name in os.listdir(args.model_path) if os.path.isdir(os.path.join(args.model_path, name)) and name != "sup"]
if len(dirs) > 0:
    start = len(dirs)

for i in range(start, args.num_rounds):
    print(f"------------Round {i}------------")
    # evaluate the model
    if i == 0:
        sub_dir = ""
        output_dir = "1"
    else:
        sub_dir = str(i)
        output_dir = str(i+1)
    pos_acc, neg_acc = one_feedback_rd(args, sub_dir, output_dir)
    # n_RL_train = np.loadtxt(join(args.model_path, sub_dir, 'train_by_hl.txt'), delimiter=' ', dtype=str).shape[0]
    img_acc, rl_rwd = one_evaluate(args, sub_dir)
    with open(join(args.model_path, "round_log.txt"), 'a') as f:
        print(f"{i}, {img_acc}, {rl_rwd}, {pos_acc}, {neg_acc}", file = f)

args.logger.close()